# encoding: UTF-8

$LOAD_PATH << '.'

require 'json'
require 'htmlentities'
require 'file_facilities'
require 'filter_tweet_data'


coder = HTMLEntities.new
directories = FileFacilities.subdirectories(ARGV[1])

File.open(ARGV[0], 'w') do |arff_file|
	arff_file.puts """
% 1.  Title: Security tweets database
% 
% 2.  Source: ~/tcc/dados

@relation security


%@attribute attribute-name attribute-type -- see manual for the supported types


@attribute class-att {cybersecurity_news, cybersecurity_threats, general_security_news, spam}
@attribute text string
@attribute user string


@data
% 'strings must be put between singlequotes', 'single and double quotes must be escaped'
% class, 'text', 'usuario'
""" 

	directories.each do |directory|
		json_files = FileFacilities.class_files(directory)
		class_name = directory.match(/(.*\/)+(.+)/)[2]

		json_files.each do |json_file|
			File.open(json_file, 'r') do |file| 
				while (line = file.gets)
					#	For each line it gathers the Twitter user name and its correspondent tweet text
					tweet = JSON.parse(line)
					tweet_text = FilterTweetData.tweet_processing(coder.decode(tweet['text']))

					if (tweet['from_user'] != nil)
						from_user = tweet['from_user']
					else
						from_user = tweet['user']['screen_name']
					end
					
					arff_file.puts class_name + ", \'" + tweet_text + "\', \'" + from_user + "\'"
				end 
			end
		end
	end
end
