module FilterTweetData
  
  # Padrão entendido pela expressão regular do método abaixo 
  # hashtag 
  # 	não seguida de hashtag
  # 	não seguida de link http
  # 	seguida de um ou mais espaços ou tabs
  # 		seguida de palavra com ou sem apóstrofe e com ou sem hífen
  # 			seguida ou não de ,.;:?!

  # ou 

  # começo de linha ou um ou mais espaços
  # 	seguido de palavra com ou sem apóstrofe e com ou sem hífen
  # 			seguida ou não de ,.;:?!
  # 			seguida de um ou mais espaços ou tabs
  # 				seguido de hashtag
  def FilterTweetData.filter_tweet tweet_decoded_text
    matches = tweet_decoded_text.scan(/((#[^\s]+[ \t]+(?!#)(?!http)[[:alpha:]]+(['‘’]s?)?(-[[:alpha:]]+)?[,.;:?!]?)|((^|\s+)[[:alpha:]]+(['‘’]s?)?(-[[:alpha:]]+)?[,.;:?!]?[ \t]+#[^\s]+))+/)
    matches.each do |match|
      i = tweet_decoded_text.index(match[0])
      tweet_decoded_text[i...i+match[0].length] = match[0].gsub(/#/, '')
    end
    tweet_decoded_text
  end

  #deletes links, the string RT that means retweeted, and the username (those strings which begin with @)
  #The hashtags are kept in the tweet text
  def FilterTweetData.remove_text_metadatas tweet_text
  	tweet_text.gsub(/(https?:\/\/[a-z0-9A-Z\/\.]*[a-z0-9A-Z]*\s?)|(@[^\s]*\s?)|(RT\s?)|(www[^\s]*)/, ' ')
  	#|#[^\s]+ -> colocar quando quiser remover hashtags
  end

  # This method gets quote symbols and slashes and transform them in literal quotes
  # and slashes to be undertood by arff files
  def FilterTweetData.literalize_symbols tweet_without_metadata
  	tweet_text = tweet_without_metadata.gsub(/([\'\"])/, "\'" => "\\'", "\"" => '\"')
  	tweet_text = tweet_text.gsub(/\\\\/, '\\')
  end

  def FilterTweetData.find_tweet_patterns tweet
  	tweet = tweet.gsub(/[Aa][nN][tT][iI](-| |)[vV][iI][rR][uU][sS]/, 'antivirus')
  	tweet = tweet.gsub(/#?[jJ][oO][bB][sS]?/, 'job')
  	tweet = tweet.gsub(/[$€£¥][0-9]+(\.[0-9]+)+[^\s]*\s*(?![tTkKmMbBtTqQ])/, '@sw0value@')
  	tweet = tweet.gsub(/[vV]?[0-9]+(\.[0-9]+){2,}[^\s]*/, '@sw0version@')
    tweet = tweet.gsub(/([zZ][eE][rR][oO]|0)(-| )[dD][aA][yY]/, '@zeroday@')
    tweet = tweet.gsub(/(?<![^\s])[0-9]{4}(?![^\s])/, '@year@')
  end

  def FilterTweetData.find_acronyms tweet
    matches = tweet.scan(/(?:[A-Z]\.){2,}/, )
    matches.each do |match|
      i = tweet.index(match[0])
      tweet[i...i+match[0].length] = match[0].gsub(/./, '')
    end
    tweet = tweet.gsub(/([A-Z])\.([A-Z])/, '\1\2')
    tweet
  end

  def FilterTweetData.separate_concateneted_words tweet
    tweet = tweet.gsub(/([abd-z])([A-Z])/, '\1 \2')
  end

  def FilterTweetData.remove_tokenizable_characters tweet
    tweet = tweet.gsub(/[…\|\]\[·&•’‘_*“”`~\/=«»;,\.()*:?!+—{}<>]/, ' ')
    tweet = tweet.gsub(/\A-|-\Z|[^a-zA-Z0-9]-|-[^a-zA-Z0-9]/, ' ')
  end

  def FilterTweetData.remove_extra_white_spaces tweet
  	tweet = tweet.gsub(/\s{2,}|[\n\r\t]+/, ' ')
  	tweet = tweet.strip	
  end

  def FilterTweetData.remove_numbers_quote_characters tweet
    tweet = tweet.gsub(/\\|'|"|-/, '')
  end

  def FilterTweetData.tweet_processing(tweet_decoded_text)
  	tweet_text = filter_tweet(tweet_decoded_text)
  	tweet_text = remove_text_metadatas(tweet_decoded_text)
  	tweet_text = literalize_symbols(tweet_text)
  	tweet_text = find_tweet_patterns(tweet_text)
    tweet_text = find_acronyms(tweet_text)
    tweet_text = separate_concateneted_words(tweet_text)
    tweet_text = remove_tokenizable_characters(tweet_text)
  	tweet_text = remove_extra_white_spaces(tweet_text)
  end
  
end

