# encoding: UTF-8

$LOAD_PATH << '.'

require 'json'
require 'htmlentities'
require 'file_facilities'
require 'filter_tweet_data'
require 'matrix'
require 'tf-idf-similarity'
require 'narray'

def class_index classes_identifier, j
  ((classes_identifier.length-1).downto(0)).each do |i|
    class_last_pos = classes_identifier[i][2] 
    if j >= class_last_pos 
      return i
    end
  end
end

def tweet_index classes_identifier, k, j
  return (j-classes_identifier[k][2])
end

coder = HTMLEntities.new
directories = FileFacilities.subdirectories(ARGV[0])

tweet_messages = []
classes_identifier = []

directories.each do |directory|
  json_files = FileFacilities.class_files(directory)
  class_name = directory.match(/(.*\/)+(.+)/)[2]
  class_tweets = []
  classes_identifier << [class_name, class_tweets, tweet_messages.length]

  json_files.each do |json_file|
    File.open(json_file, 'r') do |file| 
      while (line = file.gets)
        class_tweets << line
        tweet = JSON.parse(line)
        tweet_text = FilterTweetData.tweet_processing(coder.decode(tweet['text']))
        tweet_messages << TfIdfSimilarity::Document.new(tweet_text)
      end
    end
  end
end

puts "PASSOU 1"
model = TfIdfSimilarity::TfIdfModel.new(tweet_messages, :library => :narray)
puts "PASSOU 2"
matrix = model.similarity_matrix
puts "PASSOU 3"

number_removed_tweets = 0
removed_tweets = {}
file = File.open("#{ARGV[0]}/deleted_tweets.json", "w")
deleted_tweets_file = File.open("#{ARGV[0]}/deleted_tweets_with_details.json", "w")

for i in 0...tweet_messages.length
  if removed_tweets.has_key?(i)
    next
  end
  for j in (i+1)...tweet_messages.length
    cosine_similarity = matrix[model.document_index(tweet_messages[i]), model.document_index(tweet_messages[j])]
    if cosine_similarity > 0.8
      a = class_index(classes_identifier, i)
      b = tweet_index(classes_identifier, a, i)
      tweet1 = classes_identifier[a][1][b]

      k = class_index(classes_identifier, j)
      m = tweet_index(classes_identifier, k, j)
      tweet2 = classes_identifier[k][1][m]

      deleted_tweets_file.puts "Class: #{classes_identifier[a][0]} and #{classes_identifier[k][0]} \nIndex #{b} #{m}"
      deleted_tweets_file.puts "#{tweet1}#{tweet2}\n"

      if tweet2.length == 0
        file.puts classes_identifier[a][1][b]
        classes_identifier[a][1][b] = ''
        number_removed_tweets += 1
        next
      end

      file.puts classes_identifier[k][1][m]
      classes_identifier[k][1][m] = ''
      number_removed_tweets += 1
      removed_tweets[j] = nil
    end
  end
end

puts "Were deleted #{number_removed_tweets} tweets"

file.close

for i in 0...(classes_identifier.length)
  class_name = classes_identifier[i][0]
  file = File.open("#{ARGV[0]}/#{class_name}/#{class_name}_final.json", "a")

  classes_identifier[i][1].each do |tweet|
    file.print tweet
  end
  file.close
end
